﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContainerShip
{
    internal static class ExtentionShip
    {
        private static readonly char _separatorForObject = ':';
        
        public static DrawingShip CreateDrawingShip(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawingShip(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 6)
            {
                return new DrawingContainerShip(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
               Convert.ToBoolean(strs[5]));
            }
            return null;
        }
        
        public static string GetDataForSave(this DrawingShip drawningShip)
        {
            var ship = drawningShip.Ship;
            var str =
           $"{ship.Speed}{_separatorForObject}{ship.Weight}{_separatorForObject}{ship.BodyColor.Name}";
            if (ship is not EntityContainerShip containerShip)
            {
                return str;
            }
            return
           $"{str}{_separatorForObject}{containerShip.DopColor.Name}{_separatorForObject}{containerShip.Crane}{_separatorForObject}{containerShip.Containers}";
        }

    }
}
